import processing.core.*; import ddf.minim.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; public class newyear08 extends PApplet {

// based on Blobby by Golan Levin, 1998-2006

boolean bForPrintOutput = false;

float fmouseX, fmouseY;


Vector blobVector;
int[] blobAssociatedWithPath;
Point tempPoint;
Point squareReturnPoint;
Point squareContainingPixelPoint;
Point rootPoint;
Point edgeSquarePoint;

LissaPath lissaPathArray[];
int maxLissaPaths;
int nLissaPaths;
int currentLissaPath;

int R; 
float maxVal;
int threshHold;
float cachedField[][];
int squareSize;
int xSquares, ySquares;
int nSquares;

final int MAX_BOUNDARY_LENGTH = 1000;
final int CONVERGE_TESTS = 4;
final int  CAPACITY_INCREMENT = 500;
final int  LINEAR_RETURN = 0;
final int  SPLINE_RETURN = 1;
int blobColor   = color (255,225,235);//235,240,255);
int nubbColor   = color (200,0,0);
int shadowColor = color (100,100,150);
int bgColor     = color (160,170,255);

final int N_RESAMPLES = 256;
Vec2f resampledPolygon[];
Polygon returnBlobs[];
int CURB = 0;

boolean bDoSwivel = true;

float blurMx;
float blurMy;
PImage bg;

AudioSnippet players[];
int currPlayer;
int nPlayers;

float starx, stary;

//------------------------------------------------------------------------------------------
public void setup(){
  size(640,360,P3D);
  randomSeed(4);
  initBlobby();
  initLPs();

  bg = loadImage("bg.png");

  Minim.start(this);
  nPlayers = 3;
  currPlayer = 0;
  players = new AudioSnippet[nPlayers];
  for (int i=0; i<nPlayers; i++){
    players[i] = Minim.loadSnippet("quish" + i + ".aif"); 
  }
}


public void stop(){
  // an AudioPlayer you got from Minim.loadFile()
  for (int i=0; i<nPlayers; i++){
    players[i].close();
  }
  super.stop();
}


//============================================================
public void initBlobby() {


  maxLissaPaths = 21;
  nLissaPaths   = 0;
  currentLissaPath = -1;
  lissaPathArray = new LissaPath[maxLissaPaths];

  blurMx = width/2;
  blurMy = height/2;
  starx = width * (1 - 0.618f);
  stary = 20;

  squareSize = 10;
  xSquares = width/squareSize;
  ySquares = height/squareSize;
  nSquares = xSquares * ySquares;

  // cache field
  R = 64;
  maxVal = 1024.0f;
  threshHold = 850;
  createCachedField(R);

  blobVector = new Vector(maxLissaPaths);
  blobAssociatedWithPath = new int[maxLissaPaths];
  tempPoint                  = new Point();
  squareReturnPoint          = new Point();
  squareContainingPixelPoint = new Point();
  edgeSquarePoint            = new Point();
  rootPoint                  = new Point();
  
  CURB = 0;
  returnBlobs = new Polygon[maxLissaPaths];
  for (int i=0; i<maxLissaPaths; i++){
    returnBlobs[i] = new Polygon();
  }

  resampledPolygon = new Vec2f[N_RESAMPLES];
  for (int i=0; i<N_RESAMPLES; i++){
    resampledPolygon[i] = new Vec2f();
  }




}

public void initLPs(){
  float x,y;
  for (int i=0; i<maxLissaPaths; i++){
    if (i<9){
      x = width *(0.18f + 0.005f*random(-1,1));
      y = height*(0.55f + 0.10f*(random(-1,1) + random(-1,1)));
      if (i%9 == 1){
        x = width *(0.185f);
        y = height*(0.375f);
      }
      createNewLP(x,y);
    } 
    else if (i<18){
      x = width *(0.82f + 0.005f*random(-1,1));
      y = height*(0.55f + 0.10f*(random(-1,1) + random(-1,1)));
      if (i%9 == 1){
        x = width *(0.817f);
        y = height*(0.425f);
      }
      createNewLP(x,y);
    } 
    else if (i<21){
      x = width *(0.50f + 0.005f*random(-1,1));
      y = height*(0.35f + 0.02f*(random(-1,1) + random(-1,1)));
      createNewLP(x,y);
      lissaPathArray[i].who = 2;
      lissaPathArray[i].DAMPING = 0.9325f;
    } 
    /*
    else if (i==21){
      x = blurMx;
      y = blurMy;
      createNewLP(x,y);
      lissaPathArray[i].who = 3;
      lissaPathArray[i].DAMPING = 0.85;
    }
    */
  }
}


int babyMode = 0;
public void shiftBaby(){
  babyMode = (babyMode+1)%2;
  for (int i=18; i<21; i++){
    lissaPathArray[i].vel.y += 28;
  }
}

//---------------------------------------------
public void draw(){
  background(bg);//160,170,255); 
  idleBlobby();

  pushMatrix();
  doSwivelCamera();
  drawShadowWorld();
  drawPinkWorld();
  drawLissaSpots();
  popMatrix();

  drawStar(starx, stary); 

}


//------------------------------------------------
public void drawPinkWorld(){
  pushMatrix();
  translate(0,0,-0.2f);
  fill(100,0,0, 128);
  noStroke();
  renderBlobby(3);
  translate(0,0, 0.1f);
  fill(blobColor);
  renderBlobby(2);
  popMatrix();
  fill(blobColor); 
  renderBlobby(1);
}


//------------------------------------------------
public void drawLissaSpots(){
  translate(0,0, 0.1f);
  for (int i=0; i<nLissaPaths; i++){
    lissaPathArray[i].render();
  } 
}

//------------------------------------------------
public void drawShadowWorld(){
  float x = 70.0f;
  float y = 0.958f * height;
  pushMatrix();
  translate(0, height*0.666f, 0);
  translate(0,0,0-y);
  rotateX(DEG_TO_RAD*x);
  translate(0,0, -10);

  noStroke();
  fill(shadowColor);
  renderBlobby(0);
  renderBlobby(2);
  drawCursorShadow(); 

  popMatrix();
}

//------------------------------------------------
public void doSwivelCamera(){
  if (bDoSwivel){
    if ((mouseX != 0) && (mouseY != 0)){
      float A = 0.95f;
      float B = 1.0f-A;
      blurMx = (A*blurMx + B*mouseX);
      blurMy = (A*blurMy + B*mouseY);
    }
    float swivelX = 0.4f*(blurMx - (width/2.0f))/(width/2.0f);
    float swivelY = 0.2f*(blurMy - (height/2.0f))/(height/2.0f);
    swivelX += 0.15f*sin(millis()/3000.0f);
    swivelY += 0.10f*sin(millis()/4000.0f);
    translate(width/2,0,0); 
    rotateY(swivelX);
    translate(-width/2,0,0); 
    translate(0,height/2,0); 
    rotateX(swivelY);
    translate(0,-height/2,0); 
  } 
}


//------------------------------------------------
public void drawCursorShadow(){
  pushMatrix();
  translate(mouseX, mouseY);
  scale(1.5f,1.5f,1);
  beginShape();
  vertex(0, 0);
  vertex(7, 7);
  vertex(4, 7);
  vertex(6, 13);
  vertex(4, 13);
  vertex(2, 8);
  vertex(0, 10);
  endShape(CLOSE);
  popMatrix(); 
}
//------------------------------------------------
public void drawStar(float x, float y){
  float alp = 100 + 155*noise(millis()/250.0f);
  beginShape(LINES);
  stroke(255,alp);
  vertex(x, y);
  stroke(255,0);
  vertex(x, y - 12);

  stroke(255,alp);
  vertex(x, y);
  stroke(255,0);
  vertex(x, y + 12);

  stroke(255,alp);
  vertex(x, y);
  stroke(255,0);
  vertex(x-12, y);

  stroke(255,alp);
  vertex(x, y);
  stroke(255,0);
  vertex(x+12, y);

  endShape(); 
}








//============================================================
public void idleBlobby() {


  for (int i=0; i<nLissaPaths; i++){
    lissaPathArray[i].update();
  }
  for (int i=0; i<nLissaPaths; i++){
    lissaPathArray[i].integrate();
  }

}



//============================================================
public void renderBlobby(int whichPass){

  if (nLissaPaths > 0){

    Polygon blob; 
    int nBlobs; 
    int b = 0; 
    int p = 0;
    FPoint sourcePoint;
    Point sourceSquare;
    boolean alreadyConsidered;

    float er = 8;
    switch(whichPass){
    case 2: 
      er = 8; 
      break;
    case 3: 
      er = 10; 
      break;
    }

    ////////////////////////////
    switch(whichPass){


    case 2:
    case 3:
      nBlobs = blobVector.size();
      for (b=0; b<nBlobs; b++){
        blob = (Polygon)(blobVector.elementAt(b));
        int np = resamplePolygon (blob, resampledPolygon, N_RESAMPLES);
        for (int i=0; i<np; i++){
          float px = resampledPolygon[i].x;
          float py = resampledPolygon[i].y;
          ellipse(px, py, er,er); 
        }

      }
      break;

    case 1:
      nBlobs = blobVector.size();
      for (b=0; b<nBlobs; b++){
        blob = (Polygon)(blobVector.elementAt(b));
        int np2 = blob.npoints;
        int xp[] = blob.xpoints;
        int yp[] = blob.ypoints;
        beginShape();
        for (int i=0; i<np2; i++){
          vertex(xp[i], yp[i]); 
        }
        endShape(CLOSE);
      }
      break;



    case 0:     
      CURB = 0; 
      blobVector.removeAllElements();
      for (p=0; p<nLissaPaths; p++){  

        // for each source's current position,
        sourcePoint = lissaPathArray[p].getCurrentPoint();	

        tempPoint.x = (int)round(sourcePoint.x);
        tempPoint.y = (int)round(sourcePoint.y);
        alreadyConsidered = false;

        for (b=0; b<blobVector.size(); b++){ 
          // test each of the sources to see if they need their own blob
          blob = (Polygon)(blobVector.elementAt(b)); 

          if (blob.contains(tempPoint)) { 
            blobAssociatedWithPath[p] = b;
            alreadyConsidered = true; 
          }
        }
        if (alreadyConsidered == false){
          // make, then draw the blob
          sourceSquare = getSquareContainingPixel(tempPoint.x, tempPoint.y); // get the square on that pixel
          blob = computeBoundary(sourceSquare);
          blobAssociatedWithPath[p] = blobVector.size();
          blobVector.addElement(blob);
          CURB++;

          int np2 = blob.npoints;
          int xp[] = blob.xpoints;
          int yp[] = blob.ypoints;
          beginShape();
          for (int i=0; i<np2; i++){
            vertex(xp[i], yp[i]); 
          }
          endShape(CLOSE);

        }
      }
      break;

    }


  }
}







public void createNewLP(float x, float y){
  currentLissaPath = (int) ((currentLissaPath+1)%maxLissaPaths);
  nLissaPaths = (int) (Math.min (maxLissaPaths, nLissaPaths+1));
  int who = (currentLissaPath >= maxLissaPaths/2) ? 1 : 0;
  lissaPathArray[currentLissaPath] = new LissaPath(x, y, who, currentLissaPath);
}


//============================================================
public void mousePressed() {
  
  if ((abs(mouseX - starx) < 4) && (abs(mouseY - stary) < 4)){
    currentLissaPath = -1;
    nLissaPaths = 0;
    initLPs();
  }

  players[currPlayer].pause();
  int prev = currPlayer;
  int r = (int)random(nPlayers*0.99f);
  while (r == prev){
    r = (int)random(nPlayers*0.99f);
  }
  currPlayer = r;
  players[currPlayer].rewind();
  players[currPlayer].play();
  
  shiftBaby();
}

//============================================================
public void mouseDragged () {
}

//============================================================
public void mouseMoved () {
}

//============================================================
public void mouseReleased () { 

}

//============================================================
public void keyPressed () {
  switch ((char)key){
  default:
  case ' ':
    currentLissaPath = -1;
    nLissaPaths = 0;
    initLPs();
    break;

    /*
  case '=': 
     case '+':
     threshHold = Math.max(50, threshHold - 25); 
     break;
     case '-': 
     case '_':
     threshHold = Math.min((int)maxVal, threshHold + 25); 
     break;
     */

  }
}









class LissaPath {
  FPoint pos;
  FPoint vel;
  FPoint force;
  FPoint center;
  FPoint radii;
  FPoint speeds;

  FPoint eyeDisp;
  float eyeTargetAng;
  int    who;
  int    id;

  float DAMPING             = random(0.93f, 0.970f);
  float FORCE_MYCENTER_ATTR = random(0.05f, 0.12f);
  float FORCE_OTHER_SEP     = random(25, 35);
  float FORCE_CURSOR        = 10;
  float FORCE_BABY          = 1200;

  LissaPath (float x, float y, int w, int i){

    id = i;
    who = w;
    center = new FPoint(x,y);

    float rx = random(4,10);
    float ry = random(4,10);
    radii  = new FPoint(rx,ry);

    float sx = random(1, 4);
    float sy = random(1, 4);
    speeds = new FPoint(sx,sy);

    pos = new FPoint(x,y);
    vel = new FPoint(0,0);
    force = new FPoint(0,0);

    eyeDisp = new FPoint(0,0);
    eyeTargetAng = 0;
  }

  public void update(){

      if (id == 21){
        float dmx = (width- (0.75f*(mouseX-width/2) + width/2)) - pos.x;
        float dmy = height*0.85f /*min(mouseY, height*0.95)*/ - (pos.y +20);

        force.x = (dmx * 0.015f);
        force.y = (dmy * 0.085f);
        force.y += 0.75f*sin(millis()/135.0f);
        return;
      }
      
    force.x = 0;
    force.y = 0;
    float dx,dy,dh;
    float dir = ((id % 2) == 0) ? -1 : 1;

    float t = millis()/1000.0f;
    float cx = center.x + radii.x*sin(speeds.x * t);
    float cy = center.y + radii.y*sin(speeds.y * t);


    // restorative constant force around personal centerpoint
    float dcx = cx - pos.x;
    float dcy = cy - pos.y;
    float dch = sqrt(dcx*dcx + dcy*dcy);
    if (dch > 1.0f){
      //dcx /= dch;
      //dcy /= dch;
      float fcx = dcx * FORCE_MYCENTER_ATTR; 
      float fcy = dcy * FORCE_MYCENTER_ATTR;
      force.x += fcx;
      force.y += fcy;
    } 

    // inverse repulsion force away from nearby who-mates
    for (int i=0; i<nLissaPaths; i++){
      LissaPath L = lissaPathArray[i];
      if ((L.id != id) && (L.who == who)){
        dx = pos.x - L.pos.x;
        dy = pos.y - L.pos.y;
        dh = (dx*dx + dy*dy);
        if (dh > 0.001f){
          dx /= dh;
          dy /= dh;
          float fwx = dx * FORCE_OTHER_SEP;
          float fwy = dy * FORCE_OTHER_SEP;
          force.x += fwx - dir*dy*0.4f;
          force.y += fwy + dir*dx*0.4f;
        } 

      } 
      else if (L.who == 2){ // baby
        dx = pos.x - L.pos.x;
        dy = pos.y - L.pos.y;
        dh = sqrt(dx*dx + dy*dy);
        if (dh > 8){
          dx /= pow(dh,2.5f);
          dy /= pow(dh,2.5f);
          float fwx = dx * FORCE_BABY;
          float fwy = dy * FORCE_BABY;
          force.x -= fwx;
          force.y -= fwy;
        } 
      } 

    }



  }

  //------------------------------------
  public void integrate(){
    vel.x += force.x;
    vel.y += force.y;
    vel.x *= DAMPING;
    vel.y *= DAMPING;
    pos.x += vel.x;
    pos.y += vel.y;
  }

  //------------------------------------
  public FPoint getCurrentPoint(){
    return pos;
  }

  //------------------------------------
  public void render(){




    float vx = vel.x;
    float vy = vel.y;
    float vh = sqrt(vx*vx + vy*vy);
    float ang = atan2(vy,vx);
    vh *= 2.5f;
    vh = min(vh,10); 

    float alp = 10 + 0.25f*sq(vh);
    noStroke();
    switch(who){
    case 0: 
      fill(100,0,100, alp); 
      break;
    case 1: 
      fill(255,0,0, alp);   
      break;
    case 2:
      fill(0,170,240, alp);
      break;
    case 3:
      fill(blobColor);
      break;
    }

    if ((id%9 == 1) || (id == 21)) { // eye
      pushMatrix();
      translate(pos.x, pos.y, 0);
      if (id != 21){
        scale(1.25f,1.25f,1);
      } else {
        scale(0.9f,0.9f, 1);
      }

      fill(20,0,0, 20);
      ellipse(0,0, 19,19);
      translate(0,0,0.02f);
      ellipse(0,0, 17,17);
      translate(0,0,0.02f);
      fill(255);
      ellipse(0,0, 13,13);

      // pupil
      float targetX = mouseX;
      float targetY = mouseY;
      float dmx = mouseX - blurMx;
      float dmy = mouseY - blurMy;
      float dmh = sqrt(dmx*dmx + dmy*dmy);
      if (id == 21){ // for pet
        ;
        
      } else if (id != 19){ // for parents
        if (dmh < 60.0f){
          targetX = lissaPathArray[19].pos.x;
          targetY = lissaPathArray[19].pos.y;
        }
      
      } else { // for baby

        if (dmh > 90.0f){ // look straight ahead
          targetX = lissaPathArray[19].pos.x;
          targetY = lissaPathArray[19].pos.y;
        }

        float n = noise(millis()/1000.0f);
        if (n > 0.6f){
          float m = noise(millis()/888.0f);
          if (m < 0.5f){
            targetX = lissaPathArray[1].pos.x;
            targetY = lissaPathArray[1].pos.y;
          } 
          else {
            targetX = lissaPathArray[10].pos.x;
            targetY = lissaPathArray[10].pos.y;
          }
        }
      }
      
      if (random(1.0f) < 0.005f){
        
        translate(0,0, 0.03f);
        fill(100,40,40, 150);
        rect(-6.5f,-1, 13,2);
       
        
      } else {


      float edx = targetX - pos.x;
      float edy = targetY - pos.y;
      float edh = sqrt(edx*edx + edy*edy);
      if (edh > 0.001f){

        float A = 0.60f;
        float B = 1.0f - A;
        float angl = atan2(edy,edx);
        eyeTargetAng = A*eyeTargetAng + B*angl;

        edx = cos(eyeTargetAng);
        edy = sin(eyeTargetAng);
        edx *= 2.0f;
        edy *= 2.0f;
        eyeDisp.x = A*eyeDisp.x + B*edx;
        eyeDisp.y = A*eyeDisp.y + B*edy;
        translate(eyeDisp.x, eyeDisp.y, 0);
      }
      translate(0,0,0.02f);
      fill(30,54,84);
      ellipse(0,0, 6+vh/6,6+vh/6);
      translate(0,0,0.02f);
      fill(255,233,180);
      ellipse(1,-1, 2,2);
      }
      
      
      popMatrix();


    } 
    else { //regular dot

      pushMatrix();
      translate(pos.x, pos.y); 
      rotate(ang); 
      ellipse(0,0, 3+1.5f*vh, 3+vh); 
      popMatrix();

    }
  }

}



//============================================================
public void createCachedField(int maxR){
  int		x, y, dx, dy;
  int		size = (maxR*2)+1;
  float  	R2 = maxR*maxR;
  float  	R4 = R2*R2;
  float  	R6 = R4*R2;
  float  	fn = 0 - (4.00f/9.0f);
  float  	sn =     (17.0f/9.0f);
  float  	tn = 0 - (22.0f/9.0f);
  float  	r2, r4, r6;
  float  	val;

  cachedField	= new float[size][size];
  for (y=0; y<size; y++){
    for (x=0; x<size; x++){
      dx = maxR - x;
      dy = maxR - y;
      r2 = (dx*dx + dy*dy);
      r4 = r2*r2;
      r6 = r4*r2;

      if (r2 <= R2){ 
        val = (fn*r6/R6)+(sn*r4/R4)+(tn*r2/R2)+1.0f;
      } 
      else { 
        val = 0; 
      }
      cachedField[y][x] = (val * maxVal);
    }
  }
}


//============================================================
public byte evaluateSquare(int col, int row){

  byte b = 0;
  int lef = col*squareSize;
  int top = row*squareSize;
  int rit = lef + squareSize;
  int bot = top + squareSize;

  int frb = getFieldValueAtPixel(rit,bot); 
  int frt = getFieldValueAtPixel(rit,top); 
  int flt = getFieldValueAtPixel(lef,top);
  int flb = getFieldValueAtPixel(lef,bot);

  if ((frb < threshHold)){ 
    b|=(1<<0); 
  }
  if ((frt < threshHold)){ 
    b|=(1<<1); 
  }
  if ((flt < threshHold)){ 
    b|=(1<<2); 
  }
  if ((flb < threshHold)){ 
    b|=(1<<3); 
  }

  return b;
}



//============================================================
public Point findFirstSquareContainingEdge (int col, int row){
  // given the row and column of a square containing a source,
  // find the row and column of the first-discovered square 
  // near the source which contains the implicit edge
  int i, j;
  int s=0;
  int x=0; 
  int y=0;
  byte b;
  boolean foundSquare = false;

  if (nLissaPaths > 0){ // while loop won't end if there are no sources
    while (foundSquare == false){

      for (i= (col-s); i<=(col+s); i++){ // do horizontal periphery
        j = (row-s); 
        b = evaluateSquare(i, j);
        if (b>0) { 
          foundSquare = true; 
          x=i; 
          y=j;
          break; 
        }

        j = (row+s); 
        b = evaluateSquare(i, j);
        if (b>0) { 
          foundSquare = true; 
          x=i; 
          y=j;
          break; 
        }
      }

      for (j= (row-s+1); j<=(row+s-1); j++){ // do vertical periphery
        i = (col-s); 
        b = evaluateSquare(i, j);
        if (b>0) { 
          foundSquare = true; 
          x=i; 
          y=j; 
          break; 
        }

        i = (col+s); 
        b = evaluateSquare(i, j);
        if (b>0) { 
          foundSquare = true; 
          x=i; 
          y=j; 
          break; 
        }
      }
      s++;
    }
  }
  if (x==0 && y==0){
    // println("bad search");  
  }
  squareReturnPoint.x = x;
  squareReturnPoint.y = y;
  return squareReturnPoint;
}


//============================================================
public int getFieldValueAtPixel(int x, int y){
  float val = 0;
  int dx, dy, i, j;
  FPoint fpoint;
  for (int p=0; p<nLissaPaths; p++){
    fpoint = lissaPathArray[p].getCurrentPoint();
    dx = (int)round(x - fpoint.x);
    dy = (int)round(y - fpoint.y);
    if ((Math.abs(dx) <= R) && (Math.abs(dy) <= R)){
      i = R + dx; 
      j = R + dy;
      
      float s = 1.0f;
      if (p==21){ //hack for mouseBlob
        s = 0.95f;//1.05;
      }
      
      val += s * cachedField[j][i];
      
      
    } 
    else { 
      val += 0;
    }
  }
  return (int) val;
}

//============================================================
public Point converge (int col, int row, byte edge){
  // edge must be a byte valued at either 3, 6, 9 or 12
  // and indicates which edge is to be searched for the edge boundary
  Point root;
  int x1 = 0; 
  int x2 = 0;
  int y1 = 0; 
  int y2 = 0;
  float px = 0; 
  float py = 0;
  float lox = 0; 
  float loy = 0;
  float hix = 0; 
  float hiy = 0;

  int lef = col*squareSize;
  int top = row*squareSize;
  int rit = lef + squareSize;
  int bot = top + squareSize;

  switch (edge){
  case 3:	// right edge
    x1 = rit; 
    x2 = rit;
    y1 = bot; 
    y2 = top;
    break;
  case 6:	 // top edge
    x1 = lef; 
    x2 = rit;
    y1 = top; 
    y2 = top;
    break;
  case 9:	 // bottom edge
    x1 = rit; 
    x2 = lef;
    y1 = bot; 
    y2 = bot;
    break;
  case 12: // left edge
    x1 = lef; 
    x2 = lef;
    y1 = bot; 
    y2 = top;
    break;
  }

  if (getFieldValueAtPixel(x1, y1) <= getFieldValueAtPixel(x2, y2)){
    lox = x1; 
    loy = y1; 
    hix = x2; 
    hiy = y2; 
  }
  else { 
    lox = x2; 
    loy = y2; 
    hix = x1; 
    hiy = y1; 
  }

  for (int i=0; i<CONVERGE_TESTS; i++){
    px = (lox + hix)/2.0f;
    py = (loy + hiy)/2.0f;
    if (getFieldValueAtPixel((int)round(px), (int)round(py)) >= threshHold) { 
      hix = px; 
      hiy = py;
    }
    else {
      lox = px; 
      loy = py;
    }
  }
  rootPoint.x = (int)round(px);
  rootPoint.y = (int)round(py);
  return rootPoint;
}



//============================================================
public Point getSquareContainingPixel (int x, int y) {
  // determines the row and column of the square containing the pixel
  //Point p = new Point (x/squareSize, y/squareSize);
  squareContainingPixelPoint.x = x/squareSize;
  squareContainingPixelPoint.y = y/squareSize;
  return squareContainingPixelPoint; //p;
}


//============================================================
public Polygon computeBoundary(Point sourceSquare){
  // given a Point containing the row and column
  // of a square containing a source, search outward from the
  // source until we find a square which contains the edge of
  // the implicit curve; then trace along that edge, in search of
  // the other squares which contain the edge; for each such
  // square, represent its row and column in a Point, and store this
  // Point in a polygon
  // Polygon blob;
  Point startSquare;
  Point edgeSquare;
  Point edgePoint;
  boolean incomplete;
  int col, row;
  int prevRow, prevCol;
  int prevPrevRow, prevPrevCol;
  byte edge = 3;
  byte b;

  // blob = new Polygon();
  returnBlobs[CURB].reset();
  startSquare = findFirstSquareContainingEdge(sourceSquare.x, sourceSquare.y);
  prevCol = col = startSquare.x;
  prevRow = row = startSquare.y;

  incomplete = true;
  int nsegs = 1;

  do{
    prevPrevRow = prevRow;
    prevPrevCol = prevCol;
    prevRow = row; 
    prevCol = col;
    b = evaluateSquare(col, row);

    switch(b){

    case 10: 
      boolean comingFromLeft = (prevCol > prevPrevCol); 
      boolean comingFromRight = !comingFromLeft;
      if (comingFromLeft){ // down if coming from left
        row++;
        edge = 9;
      } 
      else if (comingFromRight){ // up if coming from right
        row--;	
        edge = 6;	
      }
      break; 	// UP/DOWN ITHSMUS;
    case 5:  
      boolean comingFromAbove = (prevRow > prevPrevRow);
      boolean comingFromBelow = !comingFromAbove;
      if (comingFromAbove){ // left if coming from above
        col--;	
        edge = 12;
      } 
      else if (comingFromBelow){  // right if coming from below
        col++;
        edge = 3;
      }
      break; 	// LEFT/RIGHT ISTHMUS;

    case 1: 
    case 9:  
    case 13:			
      col++;	
      edge = 3;	
      break;	// to RIGHT  
    case 2: 
    case 3:  
    case 11: 	
      row--;	
      edge = 6;	
      break; 	// to UP;
    case 4:  
    case 6:  
    case 7:	
      col--;	
      edge = 12;	
      break; 	// to LEFT;
    case 8: 
    case 12: 
    case 14:			
      row++;	
      edge = 9;	
      break;	// to DOWN;	
    case 0: 
    case 15: 
      break;
    }

    edgePoint = converge(prevCol, prevRow, edge);
    // edgeSquare = new Point(col, row);
    edgeSquarePoint.x = col;
    edgeSquarePoint.y = row;


    if (nsegs > MAX_BOUNDARY_LENGTH) { 
      incomplete = false; 
      println("failure " + millis());
      // can't find the original startPoint.  abort the search with a hack.
    } 
    else {
      if (!(/*edgeSquare*/ edgeSquarePoint.equals(startSquare))){
        returnBlobs[CURB].addPoint(edgePoint.x, edgePoint.y);
        nsegs++;
      } 
      else { 
        incomplete = false; 
        // edge has looped around. can fail if startPoint was an isthmus...
      } 
    }

  } 
  while (incomplete);
  return returnBlobs[CURB]; 
}



//------------------------------------------------------------
public float getPerimeter(Polygon path){
  float pathLength = 0.0F;
  int nPathPoints = path.npoints;
  for (int i = 0; i < nPathPoints; i++){
    float lowerx = path.xpoints[i];
      float lowery = path.ypoints[i];
      float upperx = path.xpoints[(i+1)%nPathPoints];
      float uppery = path.ypoints[(i+1)%nPathPoints];
      float Dx = upperx - lowerx;
      float Dy = uppery - lowery;
    
    float segLength = (float)Math.sqrt(Dx * Dx + Dy * Dy);
    pathLength += segLength;
  }
  return pathLength;
}

//------------------------------------------------------------
public int resamplePolygon (Polygon path, Vec2f resampledPath[], int nResamples) {
  
  int nPathPoints = path.npoints;
  float totalPathLength = getPerimeter(path);
  
  int nResampledPoints = (int)min(nResamples, totalPathLength/16.0f);

  float RSL = totalPathLength / (float)nResampledPoints;
  float prevRemainder = RSL;
  int p = 0;
  if(nPathPoints <= 1) {
    for(p = 0; p < nResampledPoints; p++){

      float lowerx = path.xpoints[0];
      float lowery = path.ypoints[0];
      
      float px = lowerx + (float)p * 0.0001F;
      float py = lowery + (float)p * 0.0001F;
      resampledPath[p].set(px, py);
    }
  }
  else {
    for (int i = 0; i < nPathPoints; i++){
      
      float lowerx = path.xpoints[i];
      float lowery = path.ypoints[i];
      float upperx = path.xpoints[(i+1)%nPathPoints];
      float uppery = path.ypoints[(i+1)%nPathPoints];
      float Dx = upperx - lowerx;
      float Dy = uppery - lowery;
      
      float segLength = (float)Math.sqrt(Dx * Dx + Dy * Dy);
      float ASL = segLength;
      float dx = Dx / segLength;
      float dy = Dy / segLength;
      float RSLdx = dx * RSL;
      float RSLdy = dy * RSL;
      float neededSpace = RSL - prevRemainder;
      if(ASL >= neededSpace){
        float remainder = ASL;
        float px = lowerx + neededSpace * dx;
        float py = lowery + neededSpace * dy;
        if(p < nResampledPoints) {
          resampledPath[p].set(px, py);
          remainder -= neededSpace;
          p++;
        }
        int nPtsToDo = (int)(remainder / RSL);
        for(int d = 0; d < nPtsToDo; d++) {
          px += RSLdx;
          py += RSLdy;
          if(p < nResampledPoints) {
            resampledPath[p].set(px, py);
            remainder -= RSL;
            p++;
          }
        }

        prevRemainder = remainder;
      }
      else{
        prevRemainder += ASL;
      }
    }
  }
  return nResampledPoints;
}


class FPoint {
  FPoint (){
    x = 0;
    y = 0; 
  }
  FPoint (float xf, float yf){
    x = xf;
    y = yf; 
  }
  float x;
  float y; 
}



//=========================================================================
class Vec2f {
  public void set(float X, float Y){
    x = X;
    y = Y;
  }

  Vec2f(float X, float Y){
    set(X, Y);
  }

  Vec2f() {
    set(0.0F, 0.0F);
  }

  float x;
  float y;
}







     /*
        int np = resamplePolygon (blob, resampledPolygon, N_RESAMPLES);
        fill(255);
        smooth();
        stroke(0,0,0);
        strokeWeight(0.5);
        for (int i=0; i<np; i++){
            float px = resampledPolygon[i].x;
            float py = resampledPolygon[i].y;
            ellipse(px, py, 8,8); 
        }
        */
        
       
        
        /*
        strokeWeight(7);
        noFill();
        stroke(0,0,0);
        smooth();
        beginShape(POINTS);
        for (int i=0; i<np; i++){
          vertex(xp[i], yp[i]); 
        }
        endShape(CLOSE);
        */





  static public void main(String args[]) {     PApplet.main(new String[] { "newyear08" });  }}